import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkUsers, ThinkUsersParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkUsers(params: ThinkUsersParam) {
  const res = await request.get<ApiResult<PageResult<ThinkUsers>>>(
    THINK_API_URL + '/think/think-users/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkUsers(params?: ThinkUsersParam) {
  const res = await request.get<ApiResult<ThinkUsers[]>>(
    THINK_API_URL + '/think/think-users',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkUsers(data: ThinkUsers) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-users',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkUsers(data: ThinkUsers) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-users',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkUsers(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-users/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkUsers(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-users/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkUsers(id: number) {
  const res = await request.get<ApiResult<ThinkUsers>>(
    THINK_API_URL + '/think/think-users/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
